clear all
close all
%Setup everything
Lx = 2.0; nx = 44; nt = 300;
dt = 0.0025; nu = 0.1;
dx = Lx/(nx-1.);
u = zeros(nx+1,1); p = zeros(nx,1);
u(10:20) = -1.0;

%iterate through time
for n=1:nt  
    %Advection and diffusion 
    i = [2:nx]';
    un = u;
    u(i) = u(i) - dt*(un(i).*(un(i+1)-un(i-1))/(2*dx));
    u(i) = u(i) + dt*nu*(un(i+1)-2.0*un(i)+un(i-1))/dx^2;
               
    %Solver for Pressure 
    for it = 1:100
        pn = p;
        i = [2:nx-2]';
        b = -0.5*(dx)*(u(i+1)-u(i-1));
        p(i) = 0.5*(p(i+1)+p(i-1))+b;
        %Boundary conditions
        p(1) = p(end-1);  p(end) = p(2);
        if (max(abs(pn-p)) < 1e-4)
            it
            break
        end
    end
    %Apply pressure
    u(i) = u(i) - 2.*dt*(p(i+1)-p(i))/dx;
    %Periodic Boundary conditions
    u(1) = u(end-1);  u(end) = u(2);
    plot(u, 'r-o'); hold on; plot(p, 'b-')
    hold off; pause(0.001)
  
end